unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TeeComma, ExtCtrls, TeeProcs, TeEngine, Chart, series, TeeTools;

type
  TForm1 = class(TForm)
    Chart1: TChart;
    TeeCommander1: TTeeCommander;
    Chart2: TChart;
    procedure FormCreate(Sender: TObject);
  private
    procedure AssignLine(LineFrom, LineTo: TDrawLines; Index: Integer);
    procedure ChartMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure DragLine(Sender: TObject);
    procedure NewLine(Sender: TObject);
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

var DrawLineTool1, DrawLineTool2: TDrawLineTool;
    AllowDrag: Boolean;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Chart1.AddSeries(TPointSeries.Create(self));
  Chart1[0].FillSampleValues();
  Chart2.AddSeries(CloneChartSeries(Chart1[0]));
  Chart2[0].ColorEachPoint := true;
  Chart1.Legend.Visible := false;
  Chart2.Legend.Visible := false;

  DrawLineTool1 := TDrawLineTool.Create(self);
  DrawLineTool1.Style := dlRectangle;
  DrawLineTool2 := CloneChartTool(DrawLineTool1, self) as TDrawLineTool;
  Chart1.Tools.Add(DrawLineTool1);
  Chart2.Tools.Add(DrawLineTool2);

  DrawLineTool1.OnNewLine := NewLine;
  DrawLineTool2.OnNewLine := NewLine;
  DrawLineTool1.OnDragLine := DragLine;
  DrawLineTool2.OnDragLine := DragLine;
  Chart1.OnMouseDown := ChartMouseDown;
  Chart2.OnMouseDown := ChartMouseDown;
end;

procedure TForm1.AssignLine(LineFrom, LineTo: TDrawLines; Index: Integer);
begin
  LineTo.Line[Index].Assign(LineFrom.Line[Index]);
end;

procedure TForm1.NewLine(Sender: TObject);
begin
  if Sender = DrawLineTool1 then
  begin
    DrawLineTool2.Lines.Add;
    AssignLine(DrawLineTool1.Lines, DrawLineTool2.Lines, DrawLineTool1.Lines.Count-1);
    Chart2.Refresh;
  end
  else //Sender = DrawLineTool2
  begin
    DrawLineTool1.Lines.Add;
    AssignLine(DrawLineTool2.Lines, DrawLineTool1.Lines, DrawLineTool1.Lines.Count-1);
    Chart1.Refresh;
  end;
end;

procedure TForm1.DragLine(Sender: TObject);
begin
  if AllowDrag then
    if Sender = DrawLineTool1 then
    begin
      AssignLine(DrawLineTool1.Lines, DrawLineTool2.Lines, DrawLineTool1.Selected.Index);
      Chart2.Refresh;
    end
    else
    begin
      AssignLine(DrawLineTool2.Lines, DrawLineTool1.Lines, DrawLineTool2.Selected.Index);
      Chart1.Refresh;
    end;
end;

procedure TForm1.ChartMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if (DrawLineTool1.Clicked(X,Y) <> nil) or (DrawLineTool2.Clicked(X,Y) <> nil) then
    AllowDrag := true
  else
    AllowDrag := false;
end;

end.
